100 'FAST.BAS         Functional Analysis System Testing
110 '
120 'DESIGNED BY:     Robert L. Causey, Dept. of Philosophy
130 '                 University of Texas at Austin, Austin, TX 78712
140 '
150 'This program is FREEWARE.  It may be copied and distributed
160 'freely.  It may also be modified.  However, any copies, whether
170 'in the original or modified form, should state the original
180 'authorship.  This program carries no guarantees and neither
190 'the author nor the University of Texas are responsible for
200 'its behavior or applications.
210 '
220 'First version coded by Michael J. Jewell during summer 1985.
230 'Code then revised further by Causey several times and used in
240 'a number of Philosophy of Science classes.
250 '  Latest Program Upd  11/09/86 FIRSTBOS$ rmv'd, rules changed
260 '  Additional comments added, March 9, 1987
270 '
280 'This program simulates the operations of abstract systems composed
290 'of various parts.  By experimenting with these systems, students
300 'develop functional analyses of their operations. They then write
310 'reports about their experiments and results.  See the text file,
320 'PHLSIM.DOC which is distributed with this program.
330 '
340 '=====================================================================
350 '                Principal Variables By Section
360 'Initial Screen Displays
370 '  INFOCHOICE$ = Variable for deciding to read or skip screens
380 'Choice of System Routine
390 '  SYSCHO$ = Variable for the choice of system
400 '  COLR(shape) = Color of shape, CIRCL, TRIANGLE, ELLIPSE, etc.
410 'Routine for Checking for Settings
420 '  SET$ = Flag set to YES if user has entered settings.  If set at YES,
430 '  program calls routine to activate these settings, i.e., replace
440 '  random color settings by those of the user.
450 'Display of System
460 '  PRODUCT, var for type of output of system, ROD, ARROW, DIAMOND
470 '  ACTCHO$  = User choice of action after display
480 'Setting Routine
490 '  FIRSTIM$  = Flag used to skip instructions after the first time user            enters setting routine
500 '  SETSHP$ : gets shape entered by user
510 '  SETCOLR$ : gets color entered by user
520 '  SCOLR(shape) = User-specified color of shape.
530 '  SETTING$(SETNUM) = Two letter code to store user settings
540 'Activate User Settings
550 'Ending Section
560 '  EXITCHO$: To end prog. or re-choose a system
570 '====================================================================
580 '                *** MAIN ***   Subroutine Calls
590 '
600  ON ERROR GOTO 1070  'General error trap
610  GOSUB 920      'Initialization Routine
620  GOSUB 1110      'Initial Screen Displays of General Info.
630  GOSUB 1900      'System Choice Routine.  Ret pt. from Ending Section
640 '
650 WHILE EXIT$<>"X"   'Infinite loop until student exits system
660    IF ACTCHO$ ="?" THEN 700 'for redisplay after help screens
670    GOSUB 2060      'Generate random colors
680    IF SET$="YES"   THEN GOSUB 2150  'Activate user settings
690   GOSUB 4800      'Activate system specs
700   GOSUB 2290      'Display system and get new user input
710 WEND 'End of infinite loop
720 '
730 '                           Ending Section
740 EXIT$="" 'Reset to no exit
750 SCREEN 0 : WIDTH 80
760 CLS  'Begin lp
770   LOCATE 8
780   PRINT "                 At this point, you can either choose to work"
790   PRINT "                 on a new system, or you can exit the program"
800   PRINT "                 entirely. To change systems, enter a C at the"
810   PRINT "                 prompt below. To exit, please enter X at the"
820   PRINT "                 prompt."
830   LOCATE 22
840   INPUT "                 Please enter C or X: "; EXITCHO$
850	  IF EXITCHO$="C" OR EXITCHO$="c" THEN 630 'jp system choice routine
860	  IF EXITCHO$="X" OR EXITCHO$="x" THEN CLS : END
870 GOTO 760 'Lp back for correct response
880 '                   End of  *** MAIN ***
890 '            ****  Normal End of Program ****
900 '====================================================================
910 '                    Initialization Routine
920 SCREEN 0 : WIDTH 80 'Sets screen in text mode
930 KEY OFF 'Turn off function key display
940 DEFINT A-Z
950 RANDOMIZE TIMER
960 DIM COLR(11) 'Array to map shapes 1-7 into colors 0-3
970 DIM SETTING$(5) 'Array for user settings
980 DIM SCOLR(7) 'Array for user color choices
990	'Shapes and colors are matched with constants
1000 TRIANGLE=1 : SQUARE=2 : CIRCL=3 : ELLIPSE=4 : ROD=5 : DIAMOND=6 : ARROW=7
1010 NOCOLOR=0 : BLUE=1 : PINK=2 : WHITE=3
1020 FIRSTIM$ ="YES"  'Init flag (see above)
1030 RETURN 'to MAIN
1040 '                   End Initialization Routine
1050 '====================================================================
1060 '                     General Error Trap
1070 CLS : PRINT : PRINT
1080 PRINT "Error has occurred; please restart the program."
1090 END  'Abnormal end of program during severe error condition
1100 '====================================================================
1110 '                Initial Display Screens
1120 'Opening statements
1130 CLS
1140 PRINT "      FFFFF  U   U  N   N   CCCC  TTTTT  III   OOO   N   N   AAA   L"
1150 PRINT "      F      U   U  NN  N  C        T     I   O   O  NN  N  A   A  L"
1160 PRINT "      FFF    U   U  N N N  C        T     I   O   O  N N N  AAAAA  L"
1170 PRINT "      F      U   U  N  NN  C        T     I   O   O  N  NN  A   A  L"
1180 PRINT "      F       UUU   N   N   CCCC    T    III   OOO   N   N  A   A  LLLLL"
1190 PRINT
1200 PRINT
1210 PRINT "             AAA   N   N   AAA   L      Y   Y   SSSS  III    SSSS"
1220 PRINT "            A   A  NN  N  A   A  L      Y   Y  S       I    S    "
1230 PRINT "            AAAAA  N N N  AAAAA  L       YYY    SSS    I     SSS "
1240 PRINT "            A   A  N  NN  A   A  L        Y        S   I        S"
1250 PRINT "            A   A  N   N  A   A  LLLLL    Y    SSSS   III   SSSS "
1260 LOCATE 22
1270 INPUT "Please hit RETURN to continue"; DUMMY$
1280 CLS : LOCATE 8 'Begin lp
1290 PRINT "                 If you wish to pass over the following "
1300 PRINT "                 instructions, please enter <S> at the "
1310 PRINT "                 prompt below. Otherwise, to view them,"
1320 PRINT "                 please hit RETURN to continue."
1330 LOCATE 22
1340 INPUT "Choice of action - (CR or S): ";INFOCHOICE$
1350   IF INFOCHOICE$="" THEN 1380  'Jp to instructions
1360   IF INFOCHOICE$="S" OR INFOCHOICE$="s" THEN RETURN 'to MAIN
1370 GOTO 1280 'Lp back for correct response
1380 CLS
1390 LOCATE 8
1400 PRINT "                 This computer simulation will provide you"
1410 PRINT "                 with the opportunity to perform experiments"
1420 PRINT "                 on an abstract system and its components."
1430 PRINT "                 You will be able to see how the state of"
1440 PRINT "                 an individual part of a system can affect"
1450 PRINT "                 the operation of the entire system, and, in"
1460 PRINT "                 turn, to discover the functional roles of"
1470 PRINT "                 the parts in controlling the overall operation"
1480 PRINT "                 of the system."
1490 LOCATE 22
1500 INPUT "Please hit RETURN to continue"; DUMMY$
1510 CLS
1520 LOCATE 8
1530 PRINT "                 The simulated system will have a fixed input,"
1540 PRINT "                 a white ellipse.  However, the colors of the "
1550 PRINT "                 components of the system will vary. As their"
1560 PRINT "                 colors change, so will the form and color of"
1570 PRINT "                 the system's output. By setting the colors of"
1580 PRINT "                 individual components, you should be able to"
1590 PRINT "                 determine the role each unit plays in the "
1600 PRINT "                 system."
1610 LOCATE 22
1620 INPUT "Please hit RETURN to continue";DUMMY$
1630 CLS
1640 LOCATE 8
1650 PRINT "                 You will be able to set the color of a component"
1660 PRINT "                 by entering S at the prompt below the DISPLAY"
1670 PRINT "                 SCREEN. When you do this, the program will enter"
1680 PRINT "                 the SETTING routine, where you will be able to"
1690 PRINT "                 enter your settings."
1700 PRINT
1710 PRINT "                 You will be able to run experiments on your"
1720 PRINT "                 settings for as long as you wish by entering K"
1730 PRINT "                 at the prompt below the DISPLAY SCREEN. If you"
1740 PRINT "                 do not enter K, then the system will return to"
1750 PRINT "                 randomly coloring the units."
1760 LOCATE 22
1770 INPUT "Please hit RETURN to continue";DUMMY$
1780 CLS
1790 LOCATE 8
1800 PRINT "                 Finally, HELP is available for you on the"
1810 PRINT "                 SYSTEM  DISPLAY level of the program.  To"
1820 PRINT "                 obtain help,  just enter a question mark"
1830 PRINT "                 (?) at the prompt on that screen."
1840 LOCATE 22
1850 INPUT "Please hit RETURN to continue";DUMMY$
1860 CLS
1870 RETURN 'to MAIN
1880 '               End Of Initial Display Screens
1890 '===================================================================
1900 '               Routine For Choice Of System
1910 CLS
1920 LOCATE 8
1930 PRINT "                 There are five systems with which you can"
1940 PRINT "                 experiment. Systems 1-4 are for experimentation, "
1950 PRINT "                 while System D is for demonstrations. At this"
1960 PRINT "                 time, please choose one with which you would like"
1970 PRINT "                 to work."
1980 PRINT : PRINT : PRINT
1990 INPUT "                 Please enter either 1, 2, 3, 4, or D: "; SYSCHO$
2000 CLS
2010 IF SYSCHO$<>"1" AND SYSCHO$<>"2" AND SYSCHO$<>"3" AND SYSCHO$<>"4" AND             SYSCHO$<>"D" AND SYSCHO$<>"d" THEN 1910  'Lp back for correct input
2020 IF SYSCHO$="d" THEN SYSCHO$="D" 'Used for uniform input
2030 RETURN 'to MAIN
2040 '                 End Choice Of System Routine
2050 '===================================================================
2060 '             Routine for Generating Random Colors
2070 'CLS
2080	COLR(TRIANGLE) = INT(4*RND)
2090	COLR(SQUARE)   = INT(4*RND)
2100	COLR(CIRCL)    = INT(4*RND)
2110	COLR(ELLIPSE)  = INT(4*RND)
2120 RETURN 'to MAIN
2130 '               End of Random Colors Routine
2140 '===================================================================
2150 '        Routine for Activating User System Settings
2160 'Colors which have been set have an "S" as a prefix to the
2170 'usual variable. This routine substitutes user color settings
2180 'for original random settings.
2190 '
2200 FOR I = 1 TO SETNUM
2210	IF LEFT$(SETTING$(I),1)="S" THEN COLR(SQUARE)=SCOLR(SQUARE)
2220	IF LEFT$(SETTING$(I),1)="T" THEN COLR(TRIANGLE)=SCOLR(TRIANGLE)
2230	IF LEFT$(SETTING$(I),1)="C" THEN COLR(CIRCL)=SCOLR(CIRCL)
2240	IF LEFT$(SETTING$(I),1)="E" THEN COLR(ELLIPSE)=SCOLR(ELLIPSE)
2250 NEXT I
2260 RETURN 'to MAIN
2270 '             End Activating User System Settings
2280 '===================================================================
2290 '            Routine for System Display and User Input
2300 '            .........................................
2310 '                  Draw System Outline
2320 CLS
2330 SCREEN 1
2340 PRINT "               System #";SYSCHO$  'Prnt # of system
2350 PRINT : PRINT
2360 PRINT "Input                             Output"
2370 LINE (50,40) - (255,145), WHITE, B 'System outline box
2380 '
2390 '                  Draw System Figures
2400 'Draw TRIANGLE
2410	LINE (152,50) - (120,90),  COLR(TRIANGLE)
2420	LINE (152,50) - (184,90),  COLR(TRIANGLE)
2430	LINE (120,90) - (184,90),  COLR(TRIANGLE)
2440	PAINT (152,60), COLR(TRIANGLE)
2450 'Draw SQUARE
2460	LINE (60,100) - (100,135), COLR(SQUARE), BF  'Draws and fills SQ
2470 'Draw CIRCLE
2480	CIRCLE (210,120),25, COLR(CIRCL)
2490	PAINT  (210,120), COLR(CIRCL)
2500 'Draw ELLIPSE of the System
2510	CIRCLE (142,118),20, COLR(ELLIPSE),,,8/18
2520	PAINT  (142,118), COLR(ELLIPSE)
2530 '            End of Basic System Figures
2540 '            ---------------------------
2550 '
2560 'Draw ELLIPSE of the Input to System
2570	CIRCLE (22,92),20,WHITE,,,10/18
2580	PAINT  (22,92),WHITE
2590 '
2600 '             Display of OUTPUT of System
2610 'Check whether any OUTPUT. If not, say so.
2620   IF COLR(BOSS) = NOCOLOR OR COLR(MOLDER) = NOCOLOR THEN 2940
2630 'In both of these cases, jp to NO OUTPUT display, continue from there
2640 '  this is a common feature of ALL systems; could be modified
2650 'If OUTPUT, then display it
2660   IF COLR(PRODUCT) = NOCOLOR THEN COLR(PRODUCT) = WHITE 'Default color
2670 '   the WHITE default is for ALL systems; could be modified
2680   IF PRODUCT = ROD     THEN GOSUB 2750  'Draw ROD
2690   IF PRODUCT = DIAMOND THEN GOSUB 2790  'Draw DIAMOND
2700   IF PRODUCT = ARROW   THEN GOSUB 2870  'Draw ARROW
2710 GOTO 3010 'Jp on to rest of display & get new user input
2720 '              End of OUTPUT Display
2730 '
2740 '              Subs for OUTPUT figures
2750 'Draw ROD
2760   LINE (272,87) - (352,92), COLR(PRODUCT), BF  'Draws & paints ROD
2770 RETURN 'to continue with display
2780 '
2790 'Draw DIAMOND
2800   LINE (295,73) - (271,92), COLR(PRODUCT)
2810   LINE (295,73) - (317,92), COLR(PRODUCT)
2820   LINE (295,110) - (271,92), COLR(PRODUCT)
2830   LINE (295,110) - (317,92), COLR(PRODUCT)
2840   PAINT (295,92), COLR(PRODUCT)
2850 RETURN 'to continue with display
2860 '
2870 'Draw ARROW
2880   LINE (272,92) - (318,92), COLR(PRODUCT)
2890   LINE (300,87) - (317,92), COLR(PRODUCT)
2900   LINE (300,97) - (317,92), COLR(PRODUCT)
2910 RETURN 'to continue with display
2920 '           End of OUTPUT Figure Drawing Subs
2930 '
2940 '                   Display of NO OUTPUT
2950 LOCATE 10
2960 PRINT "               NO OUTPUT"
2970 LINE (50,40) - (255,145), WHITE, B 'Redraw outside square so no overwrite
2980 GOTO 3010
2990 '              End of Display of Entire System Figure
3000 '
3010 '               Remainder of Display & Get User Input
3020 LOCATE 21
3030	IF SETTING$(1)="" THEN SETTING$(1)="NONE" : SETNUM=1
3040 PRINT "Current Settings: ";
3050	FOR I=1 TO SETNUM : PRINT SETTING$(I); "  "; : NEXT I
3060	PRINT
3070 ACTCHO$  = "" 'reset for user input
3080 PRINT
3090 INPUT "Enter <CR>, <S>et, <K>eep, ?, or <X>:"; ACTCHO$
3100 '
3110 SET$="NO" 'Reset for no settings. Chnged to YES if settings now specified
3120 IF ACTCHO$ <>"k" AND ACTCHO$ <>"K" AND ACTCHO$ <>"S" AND ACTCHO$ <>"s"            THEN SETTING$(1)="NONE" : SETNUM=1  'No old, no new settings to be used
3130 IF ACTCHO$ ="K" OR ACTCHO$ ="k"  THEN SET$="YES"
3140 IF ACTCHO$ ="S" OR ACTCHO$ ="s"  THEN GOSUB 3750  'Call Set Routine
3150 IF ACTCHO$ ="?" THEN GOSUB 3240  'Call HELP routine
3160 IF ACTCHO$ ="X" OR ACTCHO$ ="x"  THEN EXIT$="X"
3170 RETURN   'To MAIN
3180 'On return to MAIN, flags are set to ---
3190 '  enter Ending Section, or Re-use previous settings,
3200 '  or Activate New settings, or Repeat previous display if HELP was
3210 '  called, or Make New Random display if <CR> or junk was entered
3220 '             End of System Display & User Input Routine
3230 '===================================================================
3240 '                     ***  HELP Screens  ***
3250 CLS  'Sub of System Display & User Input Routine
3260 SCREEN 0 : WIDTH 80
3270 LOCATE 8
3280 PRINT "                 At the DISPLAY SCREEN, you have five choices"
3290 PRINT "                 of action. You can (1) press RETURN, (2) enter"
3300 PRINT "                 S, (3) enter K, (4) enter ?, or (5) enter X."
3310 PRINT "                 The following screens will discuss the effects"
3320 PRINT "                 of these options."
3330 LOCATE 22
3340 INPUT "Please hit RETURN to continue";DUMMY$
3350 CLS
3360 LOCATE 8
3370 PRINT "                                    RETURN"
3380 PRINT "                 RETURN will cause the program to display"
3390 PRINT "                 a system where the components are randomly"
3400 PRINT "                 colored, along with the resulting output."
3410 PRINT
3420 PRINT "                                      S"
3430 PRINT "                 Entering S will put the program into a mode"
3440 PRINT "                 where you can set the colors of one or more"
3450 PRINT "                 components of the system. By so doing, you can"
3460 PRINT "                 create experiments to test the workings of the"
3470 PRINT "                 system."
3480 LOCATE 22
3490 INPUT "Please hit RETURN to continue";DUMMY$
3500 CLS
3510 LOCATE 8
3520 PRINT "                                      K"
3530 PRINT "                 By entering K, you can have the computer retain"
3540 PRINT "                 the current settings while also having the shapes"
3550 PRINT "                 which have not been set be colored randomly. This"
3560 PRINT "                 feature allows for repeated tests of an"
3570 PRINT "                 hypothesis."
3580 PRINT
3590 PRINT "                                      ?"
3600 PRINT "                 Entering a question mark brings you to these HELP"
3610 PRINT "                 Screens."
3620 LOCATE 22
3630 INPUT "Please hit RETURN to continue";DUMMY$
3640 CLS
3650 LOCATE 8
3660 PRINT "                                      X"
3670 PRINT "                 Entering an X exits you from your current system."
3680 PRINT "                 Then, you can either choose to work on another "
3690 PRINT "                 system, or you can exit the program entirely."
3700 LOCATE 22
3710 INPUT "Please hit RETURN to return to the SYSTEM Screen";DUMMY$
3720 RETURN 'To where user entered ?
3730 '                  End of HELP Screens
3740 '===================================================================
3750 '   Setting Routine: Sub of System Display & User Input Routine
3760 'C=Circle...E=Ellipse...S=Square...T=Triangle
3770 'N=NoColor...B=Blue...P=Pink...W=White
3780 '
3790 SETNUM=1 'Init counter of settings
3800 CLS
3810 SCREEN 0 : WIDTH 80
3820 FOR I=1 TO 5 : SETTING$(I)="" : NEXT I  'Init settings
3830 SET$ = "YES"  'Set flag so new settings will be used in next display
3840 '
3850 IF FIRSTIM$  = "NO" THEN 3980  'Skip gen. instructions after first time
3860 IF FIRSTIM$  = "YES" THEN FIRSTIM$  = "NO" 'Set flag to skip gen. instrs.
3870 '
3880 '                  General Instructions
3890 LOCATE 8
3900 PRINT "                 With the setting routine, you can specify the"
3910 PRINT "                 colors of any shapes in the system.  This"
3920 PRINT "                 will allow you to test the system to see if "
3930 PRINT "                 specific settings affect the output."
3940 LOCATE 22
3950 INPUT "Please hit RETURN to continue";DUMMY$
3960 '
3970 '                   Choose Shape to Set
3980 CLS  'Start big setting loop
3990 LOCATE 3
4000 PRINT "                      CIRCLE............................C"
4010 PRINT "                      ELLIPSE...........................E"
4020 PRINT "                      SQUARE............................S"
4030 PRINT "                      TRIANGLE..........................T"
4040 LOCATE 10
4050 PRINT "           To specify the shape whose color you wish to set, enter the"
4060 PRINT "           letter shown to the right of its name above at the promt "
4070 PRINT "           below. For example, to choose to set the SQUARE, enter S at"
4080 PRINT "           the prompt. NOTE: To exit the setting routine and see the "
4090 PRINT "           effects of the settings, enter X below."
4100 LOCATE 22
4110 INPUT "           Shape to be set: "; SETSHP$
4120 IF SETSHP$="X" AND SETNUM=1 THEN SET$="NO" : GOTO 4770 'jp to end SUB
4130 IF SETSHP$="x" AND SETNUM=1 THEN SET$="NO" : GOTO 4770
4140 IF SETSHP$="X" OR SETSHP$="x" THEN SETNUM=SETNUM-1 : GOTO 4770
4150 IF SETSHP$<>"C" AND SETSHP$<>"c" AND SETSHP$<>"E" AND SETSHP$<>"e" AND SETSHP$<>"S" AND SETSHP$<>"s" AND SETSHP$<>"T" AND SETSHP$<>"t" THEN 3980  'Get correct response
4160   IF SETSHP$ = "c" THEN SETSHP$ = "C"  'These are for uniform display
4170   IF SETSHP$ = "e" THEN SETSHP$ = "E"
4180   IF SETSHP$ = "s" THEN SETSHP$ = "S"
4190   IF SETSHP$ = "t" THEN SETSHP$ = "T"
4200 '
4210 '             Choose Color of Setting
4220 CLS
4230 LOCATE 3
4240 PRINT "                      No Color (Shape not in system)....N"
4250 PRINT "                      BLUE..............................B"
4260 PRINT "                      PINK..............................P"
4270 PRINT "                      WHITE.............................W"
4280 LOCATE 10
4290 PRINT "           To specify the color of your chosen shape, input one of the"
4300 PRINT "           letters shown to the left of the desired color. NOTE: "
4310 PRINT "           Choosing N will erase the specified shape from the system, "
4320 PRINT "           thus negating its influence on the system and the output."
4330 LOCATE 22
4340 INPUT "           Desired color: ";SETCOLR$
4350 IF SETCOLR$<>"N" AND SETCOLR$<>"B" AND SETCOLR$<>"P" AND SETCOLR$<>"W" AND SETCOLR$<>"n" AND SETCOLR$<>"b" AND SETCOLR$<>"p" AND SETCOLR$<>"w" THEN 4220
4360 IF SETCOLR$ = "N"  OR  SETCOLR$ = "n" THEN SETCOLR = NOCOLOR
4370 IF SETCOLR$ = "B"  OR  SETCOLR$ = "b" THEN SETCOLR = BLUE
4380 IF SETCOLR$ = "P"  OR  SETCOLR$ = "p" THEN SETCOLR = PINK
4390 IF SETCOLR$ = "W"  OR  SETCOLR$ = "w" THEN SETCOLR = WHITE
4400 IF SETCOLR$ = "n" THEN SETCOLR$ = "N"  'These are for uniform display
4410 IF SETCOLR$ = "b" THEN SETCOLR$ = "B"
4420 IF SETCOLR$ = "p" THEN SETCOLR$ = "P"
4430 IF SETCOLR$ = "w" THEN SETCOLR$ = "W"
4440 CLS
4450 'Save user color choices in array
4460   IF SETSHP$ = "C"   THEN SCOLR(CIRCL)    = SETCOLR
4470   IF SETSHP$ = "E"   THEN SCOLR(ELLIPSE)  = SETCOLR
4480   IF SETSHP$ = "S"   THEN SCOLR(SQUARE)   = SETCOLR
4490   IF SETSHP$ = "T"   THEN SCOLR(TRIANGLE) = SETCOLR
4500 '
4510 'Prepare for display of settings (Two letters will signify setting)
4520   SETTING$(SETNUM) = SETSHP$ + SETCOLR$
4530 '
4540 'If same shape previously set, then revise the setting
4550 IF SETNUM > 1 THEN 4560 ELSE 4610
4560	COUNT = SETNUM-1
4570	  FOR I = 1 TO COUNT
4580	     IF SETSHP$ = LEFT$(SETTING$(I),1) THEN SETTING$(I)=SETTING$(SETNUM)		  : SETNUM = SETNUM-1  'Reset and adj. setnum
4590	  NEXT I
4600 '
4610 CLS  'Now see if another setting desired
4620 LOCATE 8
4630 PRINT "                      Current Settings Are:  ";
4640   FOR I=1 TO SETNUM
4650	  PRINT SETTING$(I) ; "  ";
4660   NEXT I
4670 PRINT
4680 LOCATE 12
4690 PRINT "           To exit the setting routine and see the results of the "
4700 PRINT "           settings, enter an X below. To enter a new setting, "
4710 PRINT "           please hit RETURN."
4720 LOCATE 22
4730 INPUT "           Choice of Action: "; SETCHO$
4740 IF SETCHO$ = "X" OR SETCHO$ = "x" THEN 4770 ELSE 4750
4750 SETNUM = SETNUM + 1  'Incr settings counter
4760 GOTO 3980	'Lp back for next setting
4770 RETURN 'To bottom Sys Disp & User Input Routine
4780 '                     End of Setting Routine
4790 '===================================================================
4800 '                     Activate System Specs
4810 'To add a new system, one needs to add more lines like those below, and
4820 'SYSTEM CHOICE routine must be modified to accept the new choice option.
4830 '
4840 'Send program to individual system specs
4850 IF SYSCHO$ = "1" THEN GOSUB 5000 'Specs for System 1
4860 IF SYSCHO$ = "2" THEN GOSUB 5280 'Specs for System 2
4870 IF SYSCHO$ = "3" THEN GOSUB 5540 'Specs for System 3
4880 IF SYSCHO$ = "4" THEN GOSUB 5840 'Specs for System 4
4890 IF SYSCHO$ = "D" THEN GOSUB 6090 'Specs for Demo System
4900 RETURN 'to MAIN
4910 '
4920 'BOSS=Executive...PRODUCT=Output Figure...MOLDER=Figure which
4930 'determines shape of output...PAINTER=Figure which determines
4940 'color of output...MESSER=Figure which throws wrench into system
4950 '       #####  Important Note  #####
4960 'In all systems, if COLR(BOSS)=NOCOLOR or COLR(MOLDER)=NOCOLOR, then
4970 '  NO OUTPUT.  This default is in Syst Disp/User Input routine
4980 '
4990 '-------------------------------------------------------------
5000 '                    Specs for System #1
5010 '
5020 MESSER=ELLIPSE
5030 BOSS=TRIANGLE
5040 'Now boss specifies MOLDER and PAINTER
5050 IF COLR(BOSS)  =  BLUE THEN MOLDER = SQUARE : PAINTER = CIRCL
5060 IF COLR(BOSS) <>  BLUE THEN MOLDER = CIRCL  : PAINTER = SQUARE
5070 'End of BOSS Specs
5080 '
5090 'Molding Rules
5100 IF COLR(MOLDER) = BLUE THEN PRODUCT = ROD
5110 IF COLR(MOLDER) = PINK THEN PRODUCT = ARROW
5120 IF COLR(MOLDER) = WHITE THEN PRODUCT = DIAMOND
5130 'MOLDING Rules
5140 '
5150 'Painting Rules
5160 IF COLR(PAINTER) = BLUE THEN COLR(PRODUCT) = WHITE
5170 IF COLR(PAINTER) = PINK THEN COLR(PRODUCT) = PINK
5180 IF COLR(PAINTER) = WHITE THEN COLR(PRODUCT) = BLUE
5190 IF COLR(PAINTER) = NOCOLOR THEN COLR(PRODUCT) = WHITE
5200 'End of PAINTING Rules
5210 '
5220 'Messer Rule
5230 IF COLR(MESSER) = PINK AND COLR(BOSS) = PINK THEN PRODUCT = ARROW : COLR(PRODUCT) = WHITE 'This is a wrench in the normal operations
5240 RETURN 'to Return to MAIN
5250 '           End Specs For System #1
5260 '---------------------------------------------------------
5270 '
5280 '                 Specs For System #2
5290 '
5300 MESSER = TRIANGLE
5310 BOSS = CIRCL
5320 'Now BOSS specifies MOLDER and PAINTER
5330 IF COLR(BOSS)  =	 WHITE	THEN MOLDER  = ELLIPSE : PAINTER = SQUARE
5340 IF COLR(BOSS)  <>  WHITE	THEN PAINTER = ELLIPSE : MOLDER  = SQUARE
5350 '            End BOSS specs
5360 '
5370 'MOLDING Rules
5380 IF COLR(MOLDER) = BLUE  THEN PRODUCT = DIAMOND
5390 IF COLR(MOLDER) = PINK  THEN PRODUCT = ROD
5400 IF COLR(MOLDER) = WHITE THEN PRODUCT = ARROW
5410 'End of MOLDING Rules
5420 '
5430 'PAINTING Rules
5440 IF COLR(PAINTER) = BLUE	 THEN COLR(PRODUCT) = PINK
5450 IF COLR(PAINTER) = PINK	 THEN COLR(PRODUCT) = BLUE
5460 IF COLR(PAINTER) = WHITE	 THEN COLR(PRODUCT) = WHITE
5470 IF COLR(PAINTER) = NOCOLOR THEN COLR(PRODUCT) = PINK
5480 'End of PAINTING Rules
5490 '
5500 IF COLR(MESSER)=BLUE AND COLR(BOSS)=WHITE THEN PRODUCT=DIAMOND : COLR(PRODUCT) = BLUE  'This is a wrench in the system
5510 RETURN 'to Return to MAIN
5520 '                   End Specs for System #2
5530 '-------------------------------------------------------------------
5540 '                    Specs for System #3
5550 '
5560 MESSER = SQUARE
5570 BOSS = ELLIPSE
5580 'BOSS specifies MOLDER and PAINTER
5590 IF COLR(BOSS) = BLUE    THEN MOLDER = CIRCL    : PAINTER = TRIANGLE
5600 IF COLR(BOSS) = PINK    THEN MOLDER = TRIANGLE : PAINTER = CIRCL
5610 IF COLR(BOSS) = WHITE   THEN MOLDER = TRIANGLE : PAINTER = CIRCL
5620 IF COLR(BOSS) = NOCOLOR THEN MOLDER = CIRCL    : PAINTER = TRIANGLE
5630 '            End BOSS Specs
5640 '
5650 'MOLDING Rules
5660 IF COLR(MOLDER) = BLUE  THEN PRODUCT = ARROW
5670 IF COLR(MOLDER) = PINK  THEN PRODUCT = DIAMOND
5680 IF COLR(MOLDER) = WHITE THEN PRODUCT = ROD
5690 'End of MOLDING Rules
5700 '
5710 'PAINTING Rules
5720 IF COLR(PAINTER) = BLUE	 THEN COLR(PRODUCT) = WHITE
5730 IF COLR(PAINTER) = PINK	 THEN COLR(PRODUCT) = BLUE
5740 IF COLR(PAINTER) = WHITE	 THEN COLR(PRODUCT) = PINK
5750 IF COLR(PAINTER) = NOCOLOR THEN COLR(PRODUCT) = WHITE
5760 'End of PAINTING Rules
5770 '
5780 'Messer Rule
5790 IF COLR(MESSER) = BLUE AND COLR(MOLDER) = BLUE THEN PRODUCT = DIAMOND : COLR(PRODUCT) = BLUE
5800 RETURN 'to Return to MAIN
5810 '                 End Specs for System #3
5820 '------------------------------------------------------------
5830 '
5840 '                    Specs for System #4
5850 BOSS = CIRCL : MESSER = ELLIPSE
5860 'BOSS specifies MOLDER and PAINTER.
5870 IF COLR(BOSS) = BLUE    THEN MOLDER = SQUARE : PAINTER = TRIANGLE
5880 IF COLR(BOSS) <> BLUE   THEN MOLDER = TRIANGLE : PAINTER = SQUARE
5890 '             End BOSS specs
5900 '
5910 'MOLDING Rules
5920 IF COLR(MOLDER) = BLUE  THEN PRODUCT = DIAMOND
5930 IF COLR(MOLDER) = PINK  THEN PRODUCT = ARROW
5940 IF COLR(MOLDER) = WHITE THEN PRODUCT = ROD
5950 'End MOLDING Rules
5960 '
5970 'PAINTING Rules
5980 IF COLR(PAINTER) = BLUE	 THEN COLR(PRODUCT) = PINK
5990 IF COLR(PAINTER) = PINK	 THEN COLR(PRODUCT) = WHITE
6000 IF COLR(PAINTER) = WHITE	 THEN COLR(PRODUCT) = BLUE
6010 'End PAINTING Rules
6020 '
6030 'MESSER Rule
6040 IF COLR(PAINTER) = NOCOLOR THEN COLR(PRODUCT) = COLR(MESSER)
6050 RETURN 'to Return to MAIN
6060 '                 End Specs for System #4
6070 '-------------------------------------------------------------------
6080 '
6090 '                 Specs for DEMO System
6100 BOSS    = SQUARE
6110 MOLDER  = ELLIPSE
6120 PAINTER = TRIANGLE
6130 MESSER  = CIRCL
6140 '
6150 'MOLDING Rules
6160 IF COLR(MOLDER) = BLUE  THEN PRODUCT = ROD
6170 IF COLR(MOLDER) = PINK  THEN PRODUCT = ARROW
6180 IF COLR(MOLDER) = WHITE THEN PRODUCT = DIAMOND
6190 'End MOLDING Rules
6200 '
6210 'PAINTING Rules
6220 IF COLR(PAINTER) = BLUE	 THEN COLR(PRODUCT) = WHITE
6230 IF COLR(PAINTER) = PINK	 THEN COLR(PRODUCT) = BLUE
6240 IF COLR(PAINTER) = WHITE	 THEN COLR(PRODUCT) = PINK
6250 IF COLR(PAINTER) = NOCOLOR THEN COLR(PRODUCT) = WHITE
6260 'End PAINTING Rules
6270 '
6280 'MESSER Rules
6290 IF COLR(MESSER) = WHITE AND COLR(BOSS) = WHITE THEN PRODUCT = ROD :		 COLR(PRODUCT) = BLUE
6300 RETURN 'to Return to MAIN
6310 '           End Specifications for DEMO System
6320 '===================================================================
