100 'INDUCT.BAS  
110 '
120 'DESIGNED and     Robert L. Causey, Dept. of Philosophy
130 'PROGRAMMED BY:   University of Texas at Austin, Austin, TX 78712
140 '
150 'This program is FREEWARE.  It may be copied and distributed
160 'freely.  It may also be modified.  However, any copies, whether
170 'in the original or modified form, should state the original
180 'authorship.  This program carries no guarantees and neither
190 'the author nor the University of Texas are responsible for
200 'its behavior or applications.
210 '
220 'First version finished on 10/08/84.
230 'Code then revised further by Causey several times and used in
240 'a number of Philosophy of Science classes.
250 '  Additional comments added, March 9, 1987
260 '
270 'This program simulates imaginary color worlds.  The student
280 'has the task of hypothesizing the laws of one of these worlds,
290 'then doing interactive experiments to test his/her hypotheses.
300 'See the text file, PHLSIM.DOC which is distributed with this program.
310 '
320 '
330 '=======================================================================
340 '
350 CLEAR
360 DEFINT A-Z
370 KEY OFF
380 DIM CNMR(10,10), SF(10,10), CNAM$(10), CSET(10,10)
390 ' CNMR(I,J)=numerical val to det color of square(I,J), where I=col,J=row
400 ' SF(I,J)=flag indicating which squares have had colors set by user
410 ' CNAM$(I)=P, W, or B, the abbrev. names of the possible colors
420 ' CSET(I,J)=tmp memory of CNMR(I,J)
430 '
440 GOSUB 2470 'Call init
450 '
460 '  ======================= Main calls ===========================
470 '
480 '                   Infinite lp til user quits
490 '
500 WHILE 1=1 'Lp til user chooses <Q>uit
510    GOSUB 1860 'Start of lp; set up rnd array
520       IF PRMTFLG=1 THEN PRMTFLG=0 : GOTO 560 'Skip prmt on first cycle
530          LINE INPUT "Action: <Q>uit,<S>et colors,<CR> "; Q$
540          IF Q$ = "Q" OR Q$ = "q"  THEN 600 'Exit lp for new prmts
550          IF Q$ = "S" OR Q$ = "s" THEN GOSUB 1070 'Call SET input proc
560     ON WORLDNUM GOSUB 2820, 2890, 2960, 3030, 3140 'Call worlds
570    GOSUB 710 'Call dsp output
580 WEND 'Lp back to set up new rnd array
590 '
600 CLS : Q$=""
610 PRINT : PRINT
620 INPUT "<T>ry again, or <Q>uit totally";Q$
630 IF Q$<>"T" AND Q$<>"Q" AND Q$<>"t" AND Q$<>"q" THEN 600
640 IF Q$="T" OR Q$="t" THEN 440 ELSE END
650 '
660 '                 -------End Main Calls---------
670 '
680 '
690 ' ======================= Dsp output proc ======================
700 '
710 CLS
720 X1=80 : Y1=1 : X2=240 : Y2=120
730 '
740 'Draw horizontal lines
750 FOR DY=0 TO 120 STEP 30
760    LINE (X1,Y1+DY)-(X2,Y1+DY)
770 NEXT DY
780 '
790 'Draw vertical lines
800 FOR DX=0 TO 160 STEP 40
810    LINE (X1+DX,Y1)-(X1+DX,Y2)
820 NEXT DX
830 '-----------------------------
840 'Paint Squares
850 FOR Y=1 TO 4      '1st row, 2nd row, ...
860     FOR X=1 TO 4  '1st col, 2nd col, ...
870         PAINT (100+40*(X-1),15+30*(Y-1)), CNMR(X,Y), 3
880     NEXT X
890 NEXT Y
900 '-------------------------------
910 LOCATE 17,1 'Adj. cursor pos
920 PRINT "               WORLD #";WORLDNUM
930 PRINT
940 IF SETON = 0 THEN 1020 'If no settings, then skip settings disp
950 PRINT "Settings were: ";
960 FOR I=1 TO 4
970    FOR J=1 TO 4
980      IF SF(I,J)=0 THEN 1000 '(I,J) not set; skip
990      PRINT CNAM$(CSET(I,J));RIGHT$(STR$(I),1);RIGHT$(STR$(J),1);"  "; 'Prnt (I,J) setting
1000    NEXT J
1010 NEXT I
1020 PRINT : PRINT : PRINT
1030 SETON = 0  'Reset flag
1040 RETURN 'To Main Calls
1050 '
1060 '               ------- End Dsp Output Proc -------
1070 ' ==================== SET Input procedure =======================
1080 '
1090 '    infinite lp til user exits with <CR>
1100 '
1110 SETON = 1  'This flag set when SET pts proc is called to show
1120 '            settings after graphics disp
1130 CLS 'Start lp
1140 ERRFLG = 1 ' This flag used to skip a setting if input error detected
1150 '
1160 '...................................
1170 'Dsp established settings in sublp
1180 '
1190    PRINT : PRINT "Established settings are:"
1200    PRINT STRING$(25,"-")
1210      FOR I=1 TO 4
1220        FOR J=1 TO 4
1230          IF SF(I,J)=0 THEN 1250 '(I,J) not set; skip
1240          PRINT CNAM$(CNMR(I,J));RIGHT$(STR$(I),1);RIGHT$(STR$(J),1) 'Prnt (I,J) setting
1250        NEXT J
1260      NEXT I
1270    PRINT
1280 '
1290 'End of settings dsp
1300 '...................................
1310 '
1320 PRINT "Enter <CR>, ?, or new setting: ";
1330 LINE INPUT IN$
1340  IF IN$="?" THEN 2060 'Jp for help
1350  IF IN$="" THEN 1500 ELSE GOSUB 1570 'Jp to ret,or call PARSE
1360 '
1370 'Return pt from PARSE subroutine
1380    IF ERRFLG = -1 THEN 1480 'Error detected, so skip settings this lp
1390 '.................................................................
1400 'After successful parsing, set values and co-ord flags
1410   IF STATE$="B" THEN CNMR(X,Y)=1 'Blue (=cyan)
1420   IF STATE$="P" THEN CNMR(X,Y)=2 'Pink (=magenta)
1430   IF STATE$="W" THEN CNMR(X,Y)=3 'White
1440     SF(X,Y)=1 'Set coord. flg
1450    STATE$=""
1460 '................................................................
1470 '
1480 GOTO 1130 ' Lp back for SET listing and more input
1490 '
1500 FOR I=1 TO 4 : FOR J=1 TO 4
1510   CSET(I,J) = CNMR(I,J) ' CSET(I,J)=tmp memory of settings
1520 NEXT J : NEXT I
1530 RETURN 'To Main Calls
1540 '
1550 '                 ------- End SET proc --------
1560 '
1570 '=============== PARSE proc (sub of SET pts proc) =============
1580 '
1590 ON ERROR GOTO 2290 'Trap for improper input
1600 'ERROR 210 below is specifically for this routine
1610 'input is IN$ from above
1620 C$="" 'C$ = cmpr version of IN$
1630 TMP$=""
1640 '
1650 '...................................................................
1660 '   Lp to make C$
1670     FOR I=1 TO LEN(IN$)
1680         TMP$=MID$(IN$,I,1) 'Get Ith char in IN$
1690         IF TMP$=" " THEN 1700 ELSE C$=C$+TMP$
1700     NEXT I
1710 '....................................................................
1720 '
1730 STATE$=MID$(C$,1,1)
1740   IF STATE$ <> "P" AND STATE$ <> "W" AND STATE$ <> "B" THEN ERROR 210
1750 X=VAL(MID$(C$,2,1))
1760   IF X <> 1 AND X <> 2 AND X <> 3 AND X <> 4 THEN ERROR 210
1770 Y=VAL(MID$(C$,3,1))
1780   IF Y <> 1 AND Y <> 2 AND Y <> 3 AND Y <> 4 THEN ERROR 210
1790 '
1800 ' Reintry point from SET input error trap
1810 '
1820 RETURN 'To SET Points proc to set values and flag (unless ERRFLG=-1)
1830 '
1840 '                ----- End PARSE proc -----
1850 '
1860 '============ Generate rnd array and reset SET flgs ===========
1870 '
1880 'FOR RANDOM 1's, 2's, 3's
1890 FOR I=1 TO 4
1900     FOR J=1 TO 4
1910           CNMR(I,J)=1+INT(3*RND)
1920     NEXT J
1930 NEXT I
1940 '
1950 '  Reset (zero) SET flgs
1960 FOR I=1 TO 4
1970   FOR J=1 TO 4
1980      SF(I,J)=0 'Init sf flgs
1990   NEXT J
2000 NEXT I
2010 '
2020 RETURN 'To main calls
2030 '
2040 '         -------End array generation--------
2050 '
2060 ' ==================== SET Help Section =======================
2070 '
2080 CLS: PRINT STRING$(39,"~")
2090 PRINT "Set colors by entering:  colornameXY"
2100 PRINT
2110 PRINT "where X, Y are integers for"
2120 PRINT "the desired square and"
2130 PRINT "colorname is P or W or B (in caps)."
2140 PRINT
2150 PRINT "X = 1,2,3,4 is the column number, and"
2160 PRINT "Y = 1,2,3,4 is the row number."
2170 PRINT
2180 PRINT "When through setting colors,"
2190 PRINT "enter <CR> to return to display."
2200 PRINT
2210 PRINT "As you set colors, the"
2220 PRINT "established settings will be listed."
2230 PRINT STRING$(39,"~")
2240 PRINT:PRINT
2250 GOTO 1190 'Jp back to SET input prompt
2260 '
2270 '               -------End of SET Help Section-------
2280 '
2290 ' ================ SET input error trap ==================
2300 '
2310 'This error routine called from defined ERROR 210
2320 CLS
2330 ERRFLG = -1 'Flag is set if error detected
2340 PRINT : PRINT
2350 PRINT : PRINT : PRINT "Improper input"
2360 PRINT
2370 PRINT "Be sure to use CAPITAL P or B or W,"
2380 PRINT "followed by two numbers, which must"
2390 PRINT "both be 1 or 2 or 3 or 4."
2400 PRINT
2410 PRINT "Please hit <CR> to continue."
2420 LINE INPUT Q$
2430 RESUME 1800  ' Jp to reintry pt near bottom of PARSE proc
2440 '
2450 '                  -------End error trap-------
2460 '
2470 ' ======================== Init ===============================
2480 '
2490 PRMTFLG=1 'To suppress prmt on first cycle
2500 RANDOMIZE TIMER
2510 '
2520 'Def color name fn, CNAM$
2530    CNAM$(1)="B"
2540    CNAM$(2)="P"
2550    CNAM$(3)="W"
2560 '
2570 'Set vars for color numbers
2580    BLUE=1
2590    PINK=2
2600    WHITE=3
2610 '
2620 'User chooses a world
2630 CLS : PRINT
2640 PRINT : PRINT "There are five different worlds."
2650 PRINT : PRINT "World 1 is the class demo world."
2660 PRINT : PRINT "The other worlds have laws which"
2670 PRINT : PRINT "you may investigate."
2680 PRINT : PRINT "Which world do you choose?"
2690 PRINT : PRINT "Carefully enter 1, 2, 3, 4, or 5";
2700 INPUT WORLDNUM
2710 IF WORLDNUM<>1 AND WORLDNUM<>2 AND WORLDNUM<>3 AND WORLDNUM<>4 AND WORLDNUM<>5 THEN 2630
2720 '
2730 SCREEN 1, 0  'Medium resol graphics
2740 COLOR 0, 1  'Pink, blue, white; black background
2750 '
2760 RETURN ' To Main Calls
2770 '
2780 '**********************************************************************
2790 '
2800 '=================== Invoke Laws procedure ============================
2810 '
2820 '          World # 1: the class demo world.
2830 '
2840 FOR J=1 TO 4
2850     CNMR(4,J) = CNMR(1,J)
2860 NEXT J
2870 RETURN
2880 '
2890 '          World # 2
2900 '
2910 FOR I=1 TO 3
2920    IF CNMR(1,1) = I THEN CNMR(1,3)=I : CNMR(2,3)=I : CNMR(3,3)=I : CNMR(4,3)=I : CNMR(1,4) = I : CNMR(2,4) = I : CNMR(3,4) = I : CNMR(4,4) = I
2930 NEXT I
2940 RETURN 'To Main Calls
2950 '
2960 '          World # 3
2970 '
2980 IF CNMR(1,1) = BLUE  THEN CNMR(2,2) = BLUE
2990 IF CNMR(2,2) = BLUE  THEN CNMR(3,3) = BLUE
3000 IF CNMR(3,3) = BLUE  THEN CNMR(4,4) = BLUE
3010 RETURN
3020 '
3030 '          World # 4
3040 '
3050 FOR I=1 TO 3
3060    IF CNMR(1,1)=I AND CNMR(4,1)=I THEN 3070 ELSE 3110
3070       FOR J=2 TO 4
3080           CNMR(1,J)=I
3090           CNMR(4,J)=I
3100       NEXT J
3110 NEXT I
3120 RETURN
3130 '
3140 '          World # 5
3150 '
3160 IF CNMR(2,1)=PINK THEN CNMR(3,1)=PINK : CNMR(2,2)=PINK : CNMR(3,2)=PINK : CNMR(2,3)=PINK : CNMR(3,3)=PINK : CNMR(2,4)=PINK : CNMR(3,4)=PINK : CNMR(4,4)=WHITE
3170 RETURN
3180 '
3190 '================== End Invoke Laws proc ===============================
